<template>
  <div>
    <confirmation-modal
      ref="transitionConfirmationModal"
      variant="success"
    />
    <b-modal
      v-if="!handledAsConfirmation"
      :visible="visible"
      centered
      :ok-disabled="$v.form.$invalid"
      ok-title="Confirm"
      @hide="onHide"
    >
      <p>{{ modalText }}</p>
      <p>{{ formHeaderText }}</p>
      <b-form-group
        invalid-feedback="Feedback is required"
        :state="!$v.form.feedback.$error && null"
      >
        <b-form-textarea
          v-model.trim="$v.form.feedback.$model"
          :placeholder="feedbackPlaceholder"
          :state="!$v.form.feedback.$error && null"
          autofocus
        />
      </b-form-group>
    </b-modal>
  </div>
</template>

<script lang="ts">
import Vue, { PropType } from 'vue';
import { BModal, BvModalEvent } from 'bootstrap-vue';
import { required } from 'vuelidate/lib/validators';
import { FILTER_VERSION_STATUS, STATUS_METADATA } from '@/common/constants';
import ConfirmationModal from '@/components/ConfirmationModal.vue';

const INITIAL_FORM = {
  feedback: '',
};

export default Vue.extend({
  components: {
    ConfirmationModal,
  },

  props: {
    filterName: {
      required: true,
      type: String,
    },
    filterVersionId: {
      required: true,
      type: String,
    },
    onConfirm: {
      required: true,
      type: Function,
    },
    status: {
      required: true,
      type: String as PropType<FILTER_VERSION_STATUS>,
    },
    visible: {
      required: true,
      type: Boolean,
    },
  },

  data() {
    return {
      form: { ...INITIAL_FORM },
    };
  },

  validations() {
    return {
      form: {
        feedback: {
          required: !!this.statusMetadata?.requiresFeedback && required,
        },
      },
    };
  },

  computed: {
    formHeaderText(): string | null {
      if (!this.statusMetadata) return null;

      return this.statusMetadata.requiresFeedback
        ? 'You need to give the user feedback for this action below:'
        : 'You can add optional feedback for this action. If you don\'t wish to do it, just leave the field blank.';
    },

    feedbackPlaceholder(): string {
      return `${this.statusMetadata?.requiresFeedback ? 'Mandatory' : 'Optional'} feedback...`;
    },

    modalText(): string | null {
      if (!this.statusMetadata) return null;

      return `
      You're about to ${this.statusMetadata.event.toLowerCase()}
      filter version #${this.filterVersionId}
      `;
    },

    statusMetadata() {
      return STATUS_METADATA[this.status];
    },

    handledAsConfirmation(): boolean {
      return this.status === FILTER_VERSION_STATUS.ENABLED;
    },
  },

  watch: {
    async visible(newVisible: boolean) {
      if (newVisible && this.handledAsConfirmation) {
        const confirm = await (this.$refs.transitionConfirmationModal as BModal).prompt(
          this.modalText,
          this.filterName,
        );
        if (confirm) {
          this.onConfirm(this.form);
        }
        this.$emit('update:visible', false);
      }
    },
  },

  methods: {
    onHide(event: BvModalEvent) {
      if (event.trigger === 'ok') {
        this.onConfirm(this.form);
      }
      this.resetForm();
      this.$emit('update:visible', false);
    },

    resetForm() {
      this.$v.form.$reset();
      this.form = { ...INITIAL_FORM };
    },
  },
});
</script>
